
C +---Buffered data for bilinear interpolation (25/04/2022 JFG)
C +   ---------------------------------------------------------
C +   Additional variables used to buffer sampling data in order to 
C +   minimize redundant operations while performing interpolation of 
C +   an input grid towards an output grid. E.g., the pixels selected 
C +   at each interpolation are not supposed to change if the grids 
C +   themselves don't change. Made by J.-F. Grailet.

      INTEGER bilNb
      
C +...bilNb  : number of sampling points actually considered. In 
C +            practice, one or five depending on the dimensions of 
C +            the input grid.

      INTEGER bilPix(mx,my,5,2)
      REAL    bilDat(mx,my,5,6)

C +...For each (i,j) pixel of the output grid,
C +...bilPix : 5 sets of 2 indexes corresponding to the five pixels 
C +            picked in the input grid for the interpolation.
C +...bilDat : 5 sets of 6 values corresponding to pre-computed values 
C +            associated to each of the five pixels from the input 
C +            grid to perform the interpolation.

      COMMON/intBil_i/bilNb,bilPix
      COMMON/intBil_r/bilDat

